diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java b/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
rename to src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
index fc6134628..aae0feea3 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFlag.java
+++ b/src/main/java/net/minecraft/core/block/entity/FlagBlockEntity.java
@@ -5,15 +5,15 @@ import java.util.Random;
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
 
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet140TileEntityData;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.net.packet.BlockEntityDataPacket;
+import net.minecraft.core.player.inventory.container.Container;
 
-public class TileEntityFlag extends TileEntity
-    implements IInventory
+public class FlagBlockEntity extends BlockEntity
+    implements Container
 {
     public final int CANVAS_WIDTH = 24;
     public final int CANVAS_HEIGHT = 16;
@@ -24,7 +24,7 @@ public class TileEntityFlag extends TileEntity
     
     public int sway = new Random().nextInt(100); // Random start value
     
-    public TileEntityFlag()
+    public FlagBlockEntity()
     {
     }
     
@@ -52,7 +52,7 @@ public class TileEntityFlag extends TileEntity
         if(colorIndex < 0 || colorIndex >= items.length) {
             return 15;
         }
-        if((items[colorIndex] != null && items[colorIndex].itemID == Item.dye.id)) {
+        if((items[colorIndex] != null && items[colorIndex].itemID == Items.DYE.id)) {
             return (byte) (items[colorIndex].getMetadata() & 0xF);
         }
         return 15;
@@ -100,7 +100,7 @@ public class TileEntityFlag extends TileEntity
         owner = tag.getStringOrDefault("Owner", "");
 
         ListTag list = tag.getList("Items");
-        items = new ItemStack[getSizeInventory()];
+        items = new ItemStack[getContainerSize()];
         for (int i = 0; i < list.tagCount(); i++)
         {
             CompoundTag compound = (CompoundTag)list.tagAt(i);
@@ -155,38 +155,38 @@ public class TileEntityFlag extends TileEntity
     }
 
     @Override
-    public int getSizeInventory() {
+    public int getContainerSize() {
         return 3;
     }
 
     @Override
-    public ItemStack getStackInSlot(int i) {
-        i -= 36;
-        if (i < 0 || i >= 3) return null;
+    public ItemStack getItem(int index) {
+        index -= 36;
+        if (index < 0 || index >= 3) return null;
         
-        return items[i];
+        return items[index];
     }
 
     @Override
-    public ItemStack decrStackSize(int index, int numToTake) {
+    public ItemStack removeItem(int index, int takeAmount) {
         index -= 36;
         if (items[index] != null)
         {
-            if (items[index].stackSize <= numToTake)
+            if (items[index].stackSize <= takeAmount)
             {
                 ItemStack stack = items[index];
                 items[index] = null;
-                onInventoryChanged();
+                setChanged();
                 return stack;
             }
             else
             {
-                ItemStack splitStack = items[index].splitStack(numToTake);
+                ItemStack splitStack = items[index].splitStack(takeAmount);
                 if (items[index].stackSize <= 0)
                 {
                     items[index] = null;
                 }
-                onInventoryChanged();
+                setChanged();
                 return splitStack;
             }
         }
@@ -198,33 +198,33 @@ public class TileEntityFlag extends TileEntity
 
     @Override
     public Packet getDescriptionPacket() {
-        return new Packet140TileEntityData(this);
+        return new BlockEntityDataPacket(this);
     }
 
     @Override
-    public void setInventorySlotContents(int index, ItemStack stack) 
+    public void setItem(int index, ItemStack stack)
     {
         index -= 36;
         items[index] = stack;
-        onInventoryChanged();
+        setChanged();
     }
 
     @Override
-    public String getInvName() 
+    public String getName()
     {
         return "Flag";
     }
 
     @Override
-    public int getInventoryStackLimit() 
+    public int getMaxStackSize()
     {
         return 1;
     }
 
     @Override
-    public boolean canInteractWith(EntityPlayer entityplayer) 
+    public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockTileEntity(x, y, z) != this)
+        if(worldObj.getBlockEntity(x, y, z) != this)
         {
             return false;
         }
@@ -232,7 +232,7 @@ public class TileEntityFlag extends TileEntity
     }
 
     @Override
-    public void sortInventory() {
+    public void sortContainer() {
         // Do nothing
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java b/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
similarity index 77%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
rename to src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
index 7fa9f4e60..32f4af1cc 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFlowerJar.java
+++ b/src/main/java/net/minecraft/core/block/entity/FlowerJarBlockEntity.java
@@ -2,9 +2,9 @@ package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet140TileEntityData;
+import net.minecraft.core.net.packet.BlockEntityDataPacket;
 
-public class TileEntityFlowerJar extends TileEntity{
+public class FlowerJarBlockEntity extends BlockEntity {
 
     public int flowerInPot;
 
@@ -24,6 +24,6 @@ public class TileEntityFlowerJar extends TileEntity{
 
     @Override
     public Packet getDescriptionPacket() {
-        return new Packet140TileEntityData(this);
+        return new BlockEntityDataPacket(this);
     }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
similarity index 78%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
rename to src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
index 1e4373d25..58eaeb004 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityFurnace.java
+++ b/src/main/java/net/minecraft/core/block/entity/FurnaceBlockEntity.java
@@ -2,30 +2,29 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntity, IInventory, ItemStack, NBTTagCompound, 
-//            NBTTagList, World, BlockFurnace, FurnaceRecipes, 
-//            Item, Block, Material, EntityPlayer
+//            BlockEntity, IInventory, ItemStack, NBTTagCompound,
+//            NBTTagList, World, FurnaceBlock, FurnaceRecipes,
+//            Item, Block, Material, Player
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFurnace;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.FurnaceBlock;
 import net.minecraft.core.crafting.LookupFuelFurnace;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.data.registry.recipe.RecipeGroup;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.container.Container;
 
 import java.util.List;
 
-public class TileEntityFurnace extends TileEntity
-        implements IInventory
+public class FurnaceBlockEntity extends BlockEntity
+        implements Container
 {
 
-    public TileEntityFurnace()
+    public FurnaceBlockEntity()
     {
         furnaceItemStacks = new ItemStack[3];
         currentBurnTime = 0;
@@ -35,32 +34,32 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public int getSizeInventory()
+	public int getContainerSize()
     {
         return furnaceItemStacks.length;
     }
 
     @Override
-	public ItemStack getStackInSlot(int i)
+	public ItemStack getItem(int index)
     {
-        return furnaceItemStacks[i];
+        return furnaceItemStacks[index];
     }
 
     @Override
-	public ItemStack decrStackSize(int i, int j)
+	public ItemStack removeItem(int index, int takeAmount)
     {
-        if(furnaceItemStacks[i] != null)
+        if(furnaceItemStacks[index] != null)
         {
-            if(furnaceItemStacks[i].stackSize <= j)
+            if(furnaceItemStacks[index].stackSize <= takeAmount)
             {
-                ItemStack itemstack = furnaceItemStacks[i];
-                furnaceItemStacks[i] = null;
+                ItemStack itemstack = furnaceItemStacks[index];
+                furnaceItemStacks[index] = null;
                 return itemstack;
             }
-            ItemStack itemstack1 = furnaceItemStacks[i].splitStack(j);
-            if(furnaceItemStacks[i].stackSize <= 0)
+            ItemStack itemstack1 = furnaceItemStacks[index].splitStack(takeAmount);
+            if(furnaceItemStacks[index].stackSize <= 0)
             {
-                furnaceItemStacks[i] = null;
+                furnaceItemStacks[index] = null;
             }
             return itemstack1;
         } else
@@ -70,17 +69,17 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public void setInventorySlotContents(int i, ItemStack itemstack)
+	public void setItem(int index, ItemStack itemstack)
     {
-        furnaceItemStacks[i] = itemstack;
-        if(itemstack != null && itemstack.stackSize > getInventoryStackLimit())
+        furnaceItemStacks[index] = itemstack;
+        if(itemstack != null && itemstack.stackSize > getMaxStackSize())
         {
-            itemstack.stackSize = getInventoryStackLimit();
+            itemstack.stackSize = getMaxStackSize();
         }
     }
 
     @Override
-	public String getInvName()
+	public String getName()
     {
         return "Furnace";
     }
@@ -90,7 +89,7 @@ public class TileEntityFurnace extends TileEntity
     {
         super.readFromNBT(nbttagcompound);
         ListTag nbttaglist = nbttagcompound.getList("Items");
-        furnaceItemStacks = new ItemStack[getSizeInventory()];
+        furnaceItemStacks = new ItemStack[getContainerSize()];
         for(int i = 0; i < nbttaglist.tagCount(); i++)
         {
             CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
@@ -129,7 +128,7 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public int getInventoryStackLimit()
+	public int getMaxStackSize()
     {
         return 64;
     }
@@ -165,12 +164,12 @@ public class TileEntityFurnace extends TileEntity
         }
         if(worldObj != null && !worldObj.isClientSide)
         {
-        	if(worldObj.getBlockId(x, y, z) == Block.furnaceStoneIdle.id) {
+        	if(worldObj.getBlockId(x, y, z) == Blocks.FURNACE_STONE_IDLE.id) {
             	if(currentBurnTime == 0 && furnaceItemStacks[0] == null) {
-            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Block.netherrack.id) {
+            		if(furnaceItemStacks[1] != null && furnaceItemStacks[1].itemID == Blocks.NETHERRACK.id) {
             			furnaceItemStacks[1].stackSize--;
             			if(furnaceItemStacks[1].stackSize <= 0) furnaceItemStacks[1] = null;
-            			BlockFurnace.updateFurnaceBlockState(true, worldObj, x, y, z);
+            			FurnaceBlock.updateFurnaceBlockState(true, worldObj, x, y, z);
             			furnaceUpdated = true;
             		}
             	}
@@ -184,9 +183,9 @@ public class TileEntityFurnace extends TileEntity
                     furnaceUpdated = true;
                     if(furnaceItemStacks[1] != null)
                     {
-                        if (furnaceItemStacks[1].getItem() == Item.bucketLava)
+                        if (furnaceItemStacks[1].getItem() == Items.BUCKET_LAVA)
                         {
-                            furnaceItemStacks[1] = new ItemStack(Item.bucket);
+                            furnaceItemStacks[1] = new ItemStack(Items.BUCKET);
                         }
                         else
                         {
@@ -220,7 +219,7 @@ public class TileEntityFurnace extends TileEntity
         }
         if(furnaceUpdated)
         {
-            onInventoryChanged();
+            setChanged();
         }
     }
 
@@ -251,7 +250,7 @@ public class TileEntityFurnace extends TileEntity
         {
             return false;
         }
-        if(furnaceItemStacks[2].stackSize < getInventoryStackLimit() && furnaceItemStacks[2].stackSize < furnaceItemStacks[2].getMaxStackSize())
+        if(furnaceItemStacks[2].stackSize < getMaxStackSize() && furnaceItemStacks[2].stackSize < furnaceItemStacks[2].getMaxStackSize())
         {
             return true;
         }
@@ -288,7 +287,7 @@ public class TileEntityFurnace extends TileEntity
     }
 
     protected void updateFurnace(){
-        BlockFurnace.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
+        FurnaceBlock.updateFurnaceBlockState(currentBurnTime > 0, worldObj, x, y, z);
     }
 
     private int getBurnTimeFromItem(ItemStack itemStack)
@@ -299,9 +298,9 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-	public boolean canInteractWith(EntityPlayer entityplayer)
+	public boolean stillValid(Player entityplayer)
     {
-        if(worldObj.getBlockTileEntity(x, y, z) != this)
+        if(worldObj.getBlockEntity(x, y, z) != this)
         {
             return false;
         }
@@ -309,7 +308,7 @@ public class TileEntityFurnace extends TileEntity
     }
 
     @Override
-    public void sortInventory() {
+    public void sortContainer() {
         // Do nothing
     }
 
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java b/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
similarity index 83%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
rename to src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
index a071b3cc1..16c673589 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityMeshGold.java
+++ b/src/main/java/net/minecraft/core/block/entity/GoldMeshBlockEntity.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet140TileEntityData;
+import net.minecraft.core.net.packet.BlockEntityDataPacket;
 import org.jetbrains.annotations.Nullable;
 
-public class TileEntityMeshGold extends TileEntity{
+public class GoldMeshBlockEntity extends BlockEntity {
     @Nullable
     public ItemStack filterItem;
     public int ticksRan = 0;
-    public TileEntityMeshGold() {
+    public GoldMeshBlockEntity() {
     }
 
     public void tick()
@@ -21,7 +21,8 @@ public class TileEntityMeshGold extends TileEntity{
         }
         ticksRan++;
     }
-    public boolean setFilterItem(EntityPlayer player, @Nullable ItemStack stack){
+
+    public boolean setFilterItem(Player player, @Nullable ItemStack stack){
         boolean success = false;
         boolean wasNull = filterItem == null;
         if (filterItem != null && player.getGamemode().consumeBlocks()){
@@ -59,6 +60,6 @@ public class TileEntityMeshGold extends TileEntity{
     }
     @Override
     public Packet getDescriptionPacket() {
-        return new Packet140TileEntityData(this);
+        return new BlockEntityDataPacket(this);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityRecordPlayer.java b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
similarity index 89%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityRecordPlayer.java
rename to src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
index e1c705439..a0265330f 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityRecordPlayer.java
+++ b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
@@ -2,15 +2,15 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntity, NBTTagCompound
+//            BlockEntity, NBTTagCompound
 
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
 import com.mojang.nbt.CompoundTag;
 
-public class TileEntityRecordPlayer extends TileEntity {
+public class JukeboxBlockEntity extends BlockEntity {
 
-    public TileEntityRecordPlayer() {
+    public JukeboxBlockEntity() {
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java b/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
rename to src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
index a5776d35d..7780f22de 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityMobSpawner.java
+++ b/src/main/java/net/minecraft/core/block/entity/MobSpawnerBlockEntity.java
@@ -1,22 +1,18 @@
 package net.minecraft.core.block.entity;
 
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.enums.EnumCreatureType;
-import net.minecraft.core.block.Block;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.MobCategory;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.AABB;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.Packet132SetMobSpawner;
+import net.minecraft.core.net.packet.SetMobSpawnerPacket;
 import net.minecraft.core.entity.SpawnListEntry;
 
 import java.util.List;
 
-// Referenced classes of package net.minecraft.src:
-//            TileEntity, World, EntityList, EntityLiving, 
-//            AxisAlignedBB, NBTTagCompound
-
-public class TileEntityMobSpawner extends TileEntity
+public class MobSpawnerBlockEntity extends BlockEntity
 {
     public int delay;
     private String mobId;
@@ -24,7 +20,7 @@ public class TileEntityMobSpawner extends TileEntity
     public double yaw2;
     private int nearby;
 
-    public TileEntityMobSpawner()
+    public MobSpawnerBlockEntity()
     {
         delay = -1;
         yaw2 = 0.0D;
@@ -54,7 +50,7 @@ public class TileEntityMobSpawner extends TileEntity
     @Override
 	public void tick()
     {
-        if (worldObj.getBlockId(x, y, z) != Block.mobspawner.id) return; // dumb fix for mp particle bug, need proper way to inform client to remove tileEntity
+        if (worldObj.getBlockId(x, y, z) != Blocks.MOBSPAWNER.id) return; // dumb fix for mp particle bug, need proper way to inform client to remove tileEntity
         yaw2 = yaw;
         if(!anyPlayerInRange())
         {
@@ -94,22 +90,22 @@ public class TileEntityMobSpawner extends TileEntity
             byte byte0 = 4;
             for(int i = 0; i < byte0; i++)
             {
-                EntityLiving entityliving = null;
+                Mob entityliving = null;
                 
                 if(mobId.equalsIgnoreCase("random")) {
-                	List<SpawnListEntry> list = worldObj.getBlockBiome(x, y, z).getSpawnableList(EnumCreatureType.monster);
+                	List<SpawnListEntry> list = worldObj.getBlockBiome(x, y, z).getSpawnableList(MobCategory.monster);
                 	
                 	SpawnListEntry entry = list.get(worldObj.rand.nextInt(list.size()));
-                	entityliving = (EntityLiving) EntityDispatcher.createEntityInWorld(EntityDispatcher.classToKeyMap.get(entry.entityClass), worldObj);
+                	entityliving = (Mob) EntityDispatcher.createEntityInWorld(EntityDispatcher.classToKeyMap.get(entry.entityClass), worldObj);
                 }else {
-                	entityliving = (EntityLiving) EntityDispatcher.createEntityInWorld(mobId, worldObj);
+                	entityliving = (Mob) EntityDispatcher.createEntityInWorld(mobId, worldObj);
                 }
                 
                 if(entityliving == null)
                 {
                     return;
                 }
-                int j = worldObj.getEntitiesWithinAABB(entityliving.getClass(), AABB.getBoundingBoxFromPool(x, y, z, x + 1, y + 1, z + 1).expand(8D, 4D, 8D)).size();
+                int j = worldObj.getEntitiesWithinAABB(entityliving.getClass(), AABB.getTemporaryBB(x, y, z, x + 1, y + 1, z + 1).grow(8D, 4D, 8D)).size();
                 if(j >= 6)
                 {
                     updateDelay();
@@ -119,7 +115,7 @@ public class TileEntityMobSpawner extends TileEntity
                 double d7 = (y + worldObj.rand.nextInt(3)) - 1;
                 double d8 = (double) z + (worldObj.rand.nextDouble() - worldObj.rand.nextDouble()) * 4D;
                 entityliving.moveTo(d6, d7, d8, worldObj.rand.nextFloat() * 360F, 0.0F);
-                if(!entityliving.getCanSpawnHere())
+                if(!entityliving.canSpawnHere())
                 {
                 	updateDelay();
                     continue;
@@ -146,7 +142,7 @@ public class TileEntityMobSpawner extends TileEntity
     @Override
 	public Packet getDescriptionPacket()
     {
-        return new Packet132SetMobSpawner(x, y, z, mobId);
+        return new SetMobSpawnerPacket(x, y, z, mobId);
     }
     
     public int countNearbySpawners() {
@@ -156,7 +152,7 @@ public class TileEntityMobSpawner extends TileEntity
     		for(int j = -r; j <= r; j++) {
     			for(int k = -r; k <= r; k++) {
     				int id = worldObj.getBlockId(x + i, y + j, z + k);
-    				if(id == Block.mobspawner.id) {
+    				if(id == Blocks.MOBSPAWNER.id) {
     					count++;
     				}
     			}
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntityNote.java b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/entity/TileEntityNote.java
rename to src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
index 7af6e129c..8ca0bac10 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntityNote.java
+++ b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
@@ -2,16 +2,16 @@ package net.minecraft.core.block.entity;
 
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntity, NBTTagCompound, World, Material
+//            BlockEntity, NBTTagCompound, World, Material
 
 import net.minecraft.core.block.material.Material;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 
-public class TileEntityNote extends TileEntity
+public class NoteBlockEntity extends BlockEntity
 {
 
-    public TileEntityNote()
+    public NoteBlockEntity()
     {
         note = 0;
         previousRedstoneState = false;
@@ -42,7 +42,7 @@ public class TileEntityNote extends TileEntity
     public void changePitch()
     {
         note = (byte)((note + 1) % 25);
-        onInventoryChanged();
+        setChanged();
     }
 
     public void triggerNote(World world, int x, int y, int z)
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
rename to src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
index 165d39805..7a0463c87 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySeat.java
+++ b/src/main/java/net/minecraft/core/block/entity/SeatBlockEntity.java
@@ -1,15 +1,15 @@
 package net.minecraft.core.block.entity;
 
-import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.world.IVehicle;
 
-public class TileEntitySeat
-    extends TileEntity
+public class SeatBlockEntity
+    extends BlockEntity
     implements IVehicle {
     private Entity passenger;
 
-    public TileEntitySeat() {
+    public SeatBlockEntity() {
         passenger = null;
     }
 
@@ -20,7 +20,7 @@ public class TileEntitySeat
         }
 
         // TODO the server really needs a better way of telling the client that a tile entity no longer exists, but this works to fix the client thinking that the seat remains if its broken in multiplayer
-        if (worldObj.getBlock(x, y, z) != Block.seat){
+        if (worldObj.getBlock(x, y, z) != Blocks.SEAT){
             ejectRider();
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java b/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
rename to src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
index faea99ca2..6919c71a6 100644
--- a/src/main/java/net/minecraft/core/block/entity/TileEntitySensor.java
+++ b/src/main/java/net/minecraft/core/block/entity/SensorBlockEntity.java
@@ -2,18 +2,19 @@ package net.minecraft.core.block.entity;
 
 import java.util.List;
 
-import net.minecraft.core.achievement.AchievementList;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockMotionSensor;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.MotionSensorBlock;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 
-public class TileEntitySensor extends TileEntity {
+public class SensorBlockEntity extends BlockEntity {
 
 	private int getSightRange(World world, int x, int y, int z, Direction facing) {
 		if(facing == Direction.NONE) {
@@ -56,7 +57,7 @@ public class TileEntitySensor extends TileEntity {
 		int maxY = Math.max(y1, y2) + 1;
 		int maxZ = Math.max(z1, z2) + 1;
 		
-		return AABB.getBoundingBoxFromPool(minX, minY, minZ, maxX, maxY, maxZ);
+		return AABB.getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
 	}
 
 	@Override
@@ -69,27 +70,27 @@ public class TileEntitySensor extends TileEntity {
 		int meta = worldObj.getBlockMetadata(x, y, z);
 		
 		boolean shouldBeActive = false;
-		Direction facing = BlockMotionSensor.getFacingDirection(meta);
+		Direction facing = MotionSensorBlock.getFacingDirection(meta);
 		int effectiveRange = getSightRange(worldObj, x, y, z, facing);
 		if(effectiveRange > 0) {
 			AABB detectionBox = getDetectionBox(x, y, z, facing, effectiveRange);
 			List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(null, detectionBox);
 			for(int i=0; i < list.size(); i++) {
 				Entity entity = list.get(i);
-				if(entity instanceof EntityPlayer) {
-					EntityPlayer player = (EntityPlayer) entity;
-					player.triggerAchievement(AchievementList.GET_SENSED);
+				if(entity instanceof Player) {
+					Player player = (Player) entity;
+					player.triggerAchievement(Achievements.GET_SENSED);
 				}
 				shouldBeActive = true;
 			}
 		}
 		
-		if(shouldBeActive && id == Block.motionsensorIdle.id) {
+		if(shouldBeActive && id == Blocks.MOTION_SENSOR_IDLE.id) {
 			worldObj.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5, y + 0.5, z + 0.5, "random.breath", 0.5f, worldObj.rand.nextFloat());
-			BlockMotionSensor.updateSensorBlockState(true, worldObj, x, y, z);
+			MotionSensorBlock.updateSensorBlockState(true, worldObj, x, y, z);
 		}
-		if(!shouldBeActive && id == Block.motionsensorActive.id) {
-			BlockMotionSensor.updateSensorBlockState(false, worldObj, x, y, z);
+		if(!shouldBeActive && id == Blocks.MOTION_SENSOR_ACTIVE.id) {
+			MotionSensorBlock.updateSensorBlockState(false, worldObj, x, y, z);
 		}
 	}
 }
